import type { ComponentSize } from '../..';
import type { DefineComponent, PropType, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../../utils';
import InputNumber from "./src/input-number";
export declare const FzInputNumber: Install<DefineComponent<{
    readonly modelValue: NumberConstructor;
    readonly id: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly step: {
        readonly type: NumberConstructor;
        readonly default: 1;
    };
    readonly stepStrictly: BooleanConstructor;
    readonly max: {
        readonly type: NumberConstructor;
        readonly default: number;
    };
    readonly min: {
        readonly type: NumberConstructor;
        readonly default: number;
    };
    readonly readonly: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "default";
    };
    readonly controls: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly controlsPosition: {
        readonly type: PropType<"" | "right">;
        readonly default: "";
    };
    readonly valueOnClear: {
        readonly type: PropType<number | "max" | "min" | null>;
        readonly default: null;
    };
    readonly name: StringConstructor;
    readonly label: StringConstructor;
    readonly placeholder: StringConstructor;
    readonly precision: {
        readonly type: NumberConstructor;
    };
    readonly validateEvent: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
}, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    change: (cur: number | undefined, prev: number | undefined) => boolean;
    blur: (e: FocusEvent) => boolean;
    focus: (e: FocusEvent) => boolean;
    input: (val: number | null | undefined) => boolean;
    "update:modelValue": (val: number | undefined) => boolean;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly modelValue: NumberConstructor;
    readonly id: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly step: {
        readonly type: NumberConstructor;
        readonly default: 1;
    };
    readonly stepStrictly: BooleanConstructor;
    readonly max: {
        readonly type: NumberConstructor;
        readonly default: number;
    };
    readonly min: {
        readonly type: NumberConstructor;
        readonly default: number;
    };
    readonly readonly: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "default";
    };
    readonly controls: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly controlsPosition: {
        readonly type: PropType<"" | "right">;
        readonly default: "";
    };
    readonly valueOnClear: {
        readonly type: PropType<number | "max" | "min" | null>;
        readonly default: null;
    };
    readonly name: StringConstructor;
    readonly label: StringConstructor;
    readonly placeholder: StringConstructor;
    readonly precision: {
        readonly type: NumberConstructor;
    };
    readonly validateEvent: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
}>> & {
    "onUpdate:modelValue"?: ((val: number | undefined) => any) | undefined;
    onChange?: ((cur: number | undefined, prev: number | undefined) => any) | undefined;
    onInput?: ((val: number | null | undefined) => any) | undefined;
    onFocus?: ((e: FocusEvent) => any) | undefined;
    onBlur?: ((e: FocusEvent) => any) | undefined;
}, {
    readonly size: ComponentSize;
    readonly disabled: boolean;
    readonly id: string;
    readonly validateEvent: boolean;
    readonly max: number;
    readonly readonly: boolean;
    readonly min: number;
    readonly step: number;
    readonly stepStrictly: boolean;
    readonly controls: boolean;
    readonly controlsPosition: "" | "right";
    readonly valueOnClear: number | "max" | "min" | null;
}, {}>>;
export type InputNumberInstance = InstanceType<typeof InputNumber>;
export * from './src/interface';
export default FzInputNumber;
