import type { InputType } from './interface';
import type { ComponentSize, IconSlotType } from '../../..';
import type { DefineComponent, PropType, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, StyleValue } from 'vue';
declare const _sfc_main: DefineComponent<{
    readonly id: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "default";
    };
    readonly disabled: BooleanConstructor;
    readonly modelValue: {
        readonly type: PropType<string | number | null | undefined>;
        readonly default: "";
    };
    readonly type: {
        readonly type: PropType<InputType>;
        readonly default: "text";
    };
    readonly resize: {
        readonly type: PropType<"horizontal" | "vertical" | "none" | "both">;
    };
    readonly autocomplete: {
        readonly type: StringConstructor;
        readonly default: "off";
    };
    readonly formatter: {
        readonly type: FunctionConstructor;
    };
    readonly parser: {
        readonly type: PropType<Function>;
    };
    readonly placeholder: {
        readonly type: StringConstructor;
    };
    readonly form: {
        readonly type: StringConstructor;
    };
    readonly readonly: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly clearable: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly showPassword: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly showWordLimit: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly suffixIcon: {
        readonly type: PropType<IconSlotType>;
    };
    readonly prefixIcon: {
        readonly type: PropType<IconSlotType>;
    };
    readonly containerRole: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly label: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly tabindex: {
        readonly type: PropType<string | number>;
        readonly default: 0;
    };
    readonly validateEvent: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly inputStyle: {
        readonly type: PropType<StyleValue>;
        readonly default: () => {};
    };
    readonly autofocus: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
}, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    "update:modelValue": (value: string) => boolean;
    input: (value: string) => boolean;
    change: (value: string) => boolean;
    focus: (evt: FocusEvent) => boolean;
    blur: (evt: FocusEvent) => boolean;
    clear: () => boolean;
    mouseleave: (evt: MouseEvent) => boolean;
    mouseenter: (evt: MouseEvent) => boolean;
    keydown: (evt: Event | KeyboardEvent) => boolean;
    compositionstart: (evt: CompositionEvent) => boolean;
    compositionupdate: (evt: CompositionEvent) => boolean;
    compositionend: (evt: CompositionEvent) => boolean;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly id: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "default";
    };
    readonly disabled: BooleanConstructor;
    readonly modelValue: {
        readonly type: PropType<string | number | null | undefined>;
        readonly default: "";
    };
    readonly type: {
        readonly type: PropType<InputType>;
        readonly default: "text";
    };
    readonly resize: {
        readonly type: PropType<"horizontal" | "vertical" | "none" | "both">;
    };
    readonly autocomplete: {
        readonly type: StringConstructor;
        readonly default: "off";
    };
    readonly formatter: {
        readonly type: FunctionConstructor;
    };
    readonly parser: {
        readonly type: PropType<Function>;
    };
    readonly placeholder: {
        readonly type: StringConstructor;
    };
    readonly form: {
        readonly type: StringConstructor;
    };
    readonly readonly: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly clearable: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly showPassword: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly showWordLimit: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly suffixIcon: {
        readonly type: PropType<IconSlotType>;
    };
    readonly prefixIcon: {
        readonly type: PropType<IconSlotType>;
    };
    readonly containerRole: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly label: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly tabindex: {
        readonly type: PropType<string | number>;
        readonly default: 0;
    };
    readonly validateEvent: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly inputStyle: {
        readonly type: PropType<StyleValue>;
        readonly default: () => {};
    };
    readonly autofocus: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
}>> & {
    "onUpdate:modelValue"?: ((value: string) => any) | undefined;
    onChange?: ((value: string) => any) | undefined;
    onInput?: ((value: string) => any) | undefined;
    onFocus?: ((evt: FocusEvent) => any) | undefined;
    onBlur?: ((evt: FocusEvent) => any) | undefined;
    onClear?: (() => any) | undefined;
    onMouseleave?: ((evt: MouseEvent) => any) | undefined;
    onMouseenter?: ((evt: MouseEvent) => any) | undefined;
    onKeydown?: ((evt: Event | KeyboardEvent) => any) | undefined;
    onCompositionstart?: ((evt: CompositionEvent) => any) | undefined;
    onCompositionupdate?: ((evt: CompositionEvent) => any) | undefined;
    onCompositionend?: ((evt: CompositionEvent) => any) | undefined;
}, {
    readonly size: ComponentSize;
    readonly type: InputType;
    readonly disabled: boolean;
    readonly autofocus: boolean;
    readonly id: string;
    readonly modelValue: string | number | null | undefined;
    readonly validateEvent: boolean;
    readonly tabindex: string | number;
    readonly label: string;
    readonly clearable: boolean;
    readonly autocomplete: string;
    readonly readonly: boolean;
    readonly showPassword: boolean;
    readonly showWordLimit: boolean;
    readonly containerRole: string;
    readonly inputStyle: StyleValue;
}, {}>;
export default _sfc_main;
