import type { NumberAnimateType } from './src/interface';
import type { ComponentSize } from '../..';
import type { DefineComponent, PropType, CSSProperties, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../../utils';
import NumberAnimate from "./src/number-animate";
export declare const FzNumberAnimate: Install<DefineComponent<{
    readonly from: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
    readonly to: {
        readonly type: NumberConstructor;
    };
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "";
    };
    readonly type: {
        readonly type: PropType<NumberAnimateType>;
        readonly default: "";
    };
    readonly duration: {
        readonly type: NumberConstructor;
        readonly default: 2000;
    };
    readonly formatter: {
        readonly type: PropType<(num: number) => string | number | null | undefined>;
        readonly default: (num: number) => string;
    };
    readonly styles: {
        readonly type: PropType<CSSProperties>;
    };
    readonly autoplay: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly loop: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly interval: {
        readonly type: NumberConstructor;
        readonly default: 3000;
    };
}, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    end: (elapsed: number) => elapsed is number;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly from: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
    readonly to: {
        readonly type: NumberConstructor;
    };
    readonly size: {
        readonly type: PropType<ComponentSize>;
        readonly default: "";
    };
    readonly type: {
        readonly type: PropType<NumberAnimateType>;
        readonly default: "";
    };
    readonly duration: {
        readonly type: NumberConstructor;
        readonly default: 2000;
    };
    readonly formatter: {
        readonly type: PropType<(num: number) => string | number | null | undefined>;
        readonly default: (num: number) => string;
    };
    readonly styles: {
        readonly type: PropType<CSSProperties>;
    };
    readonly autoplay: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly loop: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly interval: {
        readonly type: NumberConstructor;
        readonly default: 3000;
    };
}>> & {
    onEnd?: ((elapsed: number) => any) | undefined;
}, {
    readonly size: ComponentSize;
    readonly type: NumberAnimateType;
    readonly formatter: (num: number) => string | number | null | undefined;
    readonly from: number;
    readonly duration: number;
    readonly autoplay: boolean;
    readonly loop: boolean;
    readonly interval: number;
}, {}>>;
export type NumberAnimateInstance = InstanceType<typeof NumberAnimate>;
export * from './src/interface';
export default FzNumberAnimate;
