import type { Placement } from '@fz-design/fz-popperjs';
import type { ExtractPropTypes, PropType } from 'vue';
import type { Arrayable } from '../../../types';
import type { SliderMarks } from './interface';
export declare const Props: {
    readonly modelValue: {
        readonly type: PropType<Arrayable<number>>;
        readonly default: 0;
    };
    readonly id: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly min: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
    readonly max: {
        readonly type: NumberConstructor;
        readonly default: 100;
    };
    readonly step: {
        readonly type: NumberConstructor;
        readonly default: 1;
    };
    readonly showInput: BooleanConstructor;
    readonly showInputControls: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly size: {
        readonly type: StringConstructor;
    };
    readonly inputSize: {
        readonly type: StringConstructor;
    };
    readonly showStops: BooleanConstructor;
    readonly showTooltip: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly formatTooltip: {
        readonly type: PropType<(val: number) => number | string>;
        readonly default: undefined;
    };
    readonly disabled: BooleanConstructor;
    readonly range: BooleanConstructor;
    readonly vertical: BooleanConstructor;
    readonly height: StringConstructor;
    readonly debounce: {
        readonly type: NumberConstructor;
        readonly default: 300;
    };
    readonly label: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly rangeStartLabel: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly rangeEndLabel: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly formatValueText: {
        readonly type: PropType<(val: number) => string>;
        readonly default: undefined;
    };
    readonly tooltipClass: {
        readonly type: StringConstructor;
        readonly default: undefined;
    };
    readonly placement: {
        readonly type: PropType<Placement>;
        readonly default: "top";
    };
    readonly marks: {
        readonly type: PropType<SliderMarks>;
    };
    readonly validateEvent: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
};
export declare const Emits: {
    "update:modelValue": (value: Arrayable<number>) => boolean;
    input: (value: Arrayable<number>) => boolean;
    change: (value: Arrayable<number>) => boolean;
};
export type SliderEmits = typeof Emits;
export type SliderProps = ExtractPropTypes<typeof Props>;
