import type { ExtractPropTypes, PropType } from 'vue';
import type { SwapType } from './interface';
import type { IconSlotType } from '../../../types';
export declare const Props: {
    /**
     *  绑定值
     */
    readonly modelValue: {
        readonly type: PropType<string | number | boolean>;
        readonly default: false;
    };
    /** 组件尺寸 */
    readonly size: {
        readonly type: PropType<string | number>;
    };
    /**
     * 动画类型
     *
     * @values sound swap
     */
    readonly type: {
        readonly type: PropType<SwapType>;
    };
    /** 打开展示的图标 */
    readonly iconOn: {
        readonly type: PropType<IconSlotType>;
        readonly default: () => any;
    };
    /** 关闭展示的图标 */
    readonly iconOff: {
        readonly type: PropType<IconSlotType>;
        readonly default: () => any;
    };
    /**
     *  开启时的值
     */
    readonly activeValue: {
        readonly type: PropType<string | number | boolean>;
        readonly default: true;
    };
    /**
     *  关闭时的值
     */
    readonly inactiveValue: {
        readonly type: PropType<string | number | boolean>;
        readonly default: false;
    };
};
export type SwapProps = ExtractPropTypes<typeof Props>;
