import { defineComponent as re, ref as te, reactive as oe, computed as v, watch as ue, onMounted as ie, onUpdated as le, openBlock as z, createElementBlock as D, normalizeClass as x, unref as u, withModifiers as w, withDirectives as G, withKeys as g, createVNode as M, createCommentVNode as H } from "vue";
import { Props as ae, Emits as se } from "./index3.js";
import { useLocale as ce } from "../../../hooks/index9.js";
import me from "../../../../fz-design-icon/src/icon-chevron-down/index.js";
import pe from "../../../../fz-design-icon/src/icon-minus/index.js";
import { vRepeatClick as W } from "../../../directives/repeat-click/index.js";
import de from "../../../../fz-design-icon/src/icon-chevron-up/index.js";
import fe from "../../../../fz-design-icon/src/icon-plus/index.js";
import { FzInput as be } from "../../input/index.js";
import { useNamespace as ve } from "../../../hooks/index11.js";
import { useFormItem as Ne } from "../../form/src/hooks/index2.js";
import { isNumber as d, isUndefined as y, isNil as K, isString as Ve } from "../../../utils/lodash/index2.js";
import { warning as k, throwError as he } from "../../../utils/console/index.js";
import { useFormSize as we, useFormDisabled as ge } from "../../form/src/hooks/index.js";
import { UPDATE_MODEL_EVENT as I, INPUT_EVENT as T, CHANGE_EVENT as ye } from "../../../constants/index.js";
import { FzSvgIcon as j } from "../../svg-icon/index.js";
const Ie = ["aria-label", "onKeydown"], Se = ["aria-label", "onKeydown"];
var Re = /* @__PURE__ */ re({
  name: "FzInputNumber",
  __name: "input-number",
  props: ae,
  emits: se,
  setup(q, { expose: J, emit: s }) {
    const t = q, { t: U } = ce(), a = ve("input-number"), f = te(), i = oe({
      currentValue: t.modelValue,
      userInput: null
    }), { formItem: c } = Ne(), B = v(
      () => d(t.modelValue) && t.modelValue <= t.min
    ), O = v(
      () => d(t.modelValue) && t.modelValue >= t.max
    ), Q = v(() => {
      const e = R(t.step);
      return y(t.precision) ? Math.max(R(t.modelValue), e) : (e > t.precision && k(
        "InputNumber",
        "precision should not be less than the decimal places of step"
      ), t.precision);
    }), S = v(() => t.controls && t.controlsPosition === "right"), L = we(), b = ge(), A = v(() => {
      if (i.userInput !== null)
        return i.userInput;
      let e = i.currentValue;
      if (K(e))
        return "";
      if (d(e)) {
        if (Number.isNaN(e))
          return "";
        y(t.precision) || (e = e.toFixed(t.precision));
      }
      return e;
    }), E = (e, n) => {
      if (y(n) && (n = Q.value), n === 0)
        return Math.round(e);
      let r = String(e);
      const o = r.indexOf(".");
      if (o === -1 || !r.replace(".", "").split("")[o + n])
        return e;
      const V = r.length;
      return r.charAt(V - 1) === "5" && (r = `${r.slice(0, Math.max(0, V - 1))}6`), Number.parseFloat(Number(r).toFixed(n));
    }, R = (e) => {
      if (K(e))
        return 0;
      const n = e.toString(), r = n.indexOf(".");
      let o = 0;
      return r !== -1 && (o = n.length - r - 1), o;
    }, $ = (e, n = 1) => d(e) ? E(e + t.step * n) : i.currentValue, F = () => {
      if (t.readonly || b.value || O.value)
        return;
      const e = Number(A.value) || 0, n = $(e);
      N(n), s(T, i.currentValue);
    }, P = () => {
      if (t.readonly || b.value || B.value)
        return;
      const e = Number(A.value) || 0, n = $(e, -1);
      N(n), s(T, i.currentValue);
    }, C = (e, n) => {
      const { max: r, min: o, step: p, precision: m, stepStrictly: V, valueOnClear: h } = t;
      r < o && he("InputNumber", "min should not be greater than max.");
      let l = Number(e);
      if (K(e) || Number.isNaN(l))
        return null;
      if (e === "") {
        if (h === null)
          return null;
        l = Ve(h) ? { min: o, max: r }[h] : h;
      }
      return V && (l = E(Math.round(l / p) * p, m)), y(m) || (l = E(l, m)), (l > r || l < o) && (l = l > r ? r : o, n && s(I, l)), l;
    }, N = (e, n = !0) => {
      var p;
      const r = i.currentValue, o = C(e);
      if (!n) {
        s(I, o);
        return;
      }
      r !== o && (i.userInput = null, s(I, o), s(ye, o, r), t.validateEvent && ((p = c == null ? void 0 : c.validate) == null || p.call(c, "change").catch((m) => k(a.b(), m))), i.currentValue = o);
    }, X = (e) => {
      i.userInput = e;
      const n = e === "" ? null : Number(e);
      s(T, n), N(n, !1);
    }, Y = (e) => {
      const n = e !== "" ? Number(e) : "";
      (d(n) && !Number.isNaN(n) || e === "") && N(n), i.userInput = null;
    }, Z = () => {
      var e, n;
      (n = (e = f.value) == null ? void 0 : e.focus) == null || n.call(e);
    }, _ = () => {
      var e, n;
      (n = (e = f.value) == null ? void 0 : e.blur) == null || n.call(e);
    }, ee = (e) => {
      s("focus", e);
    }, ne = (e) => {
      var n;
      s("blur", e), t.validateEvent && ((n = c == null ? void 0 : c.validate) == null || n.call(c, "blur").catch((r) => k(a.b(), r)));
    };
    return ue(
      () => t.modelValue,
      (e) => {
        const n = C(i.userInput), r = C(e, !0);
        !d(n) && (!n || n !== r) && (i.currentValue = r, i.userInput = null);
      },
      { immediate: !0 }
    ), ie(() => {
      var p;
      const { min: e, max: n, modelValue: r } = t, o = (p = f.value) == null ? void 0 : p.input;
      if (o.setAttribute("role", "spinbutton"), Number.isFinite(n) ? o.setAttribute("aria-valuemax", String(n)) : o.removeAttribute("aria-valuemax"), Number.isFinite(e) ? o.setAttribute("aria-valuemin", String(e)) : o.removeAttribute("aria-valuemin"), o.setAttribute(
        "aria-valuenow",
        i.currentValue || i.currentValue === 0 ? String(i.currentValue) : ""
      ), o.setAttribute("aria-disabled", String(b.value)), !d(r) && r != null) {
        let m = Number(r);
        Number.isNaN(m) && (m = null), s(I, m);
      }
    }), le(() => {
      var n;
      const e = (n = f.value) == null ? void 0 : n.input;
      e == null || e.setAttribute("aria-valuenow", `${i.currentValue ?? ""}`);
    }), J({
      /** @description get focus the input component */
      focus: Z,
      /** @description remove focus the input component */
      blur: _
    }), (e, n) => (z(), D("div", {
      class: x([
        u(a).b(),
        u(a).m(u(L)),
        u(a).is("disabled", u(b)),
        u(a).is("without-controls", !e.controls),
        u(a).is("controls-right", S.value)
      ]),
      onDragstart: n[1] || (n[1] = w(() => {
      }, ["prevent"]))
    }, [
      e.controls ? G((z(), D("span", {
        key: 0,
        role: "button",
        "aria-label": u(U)("fz.inputNumber.decrease"),
        class: x([u(a).e("decrease"), u(a).is("disabled", B.value)]),
        onKeydown: g(P, ["enter"])
      }, [
        M(u(j), {
          icon: S.value ? u(me) : u(pe)
        }, null, 8, ["icon"])
      ], 42, Ie)), [
        [u(W), P]
      ]) : H("", !0),
      e.controls ? G((z(), D("span", {
        key: 1,
        role: "button",
        "aria-label": u(U)("fz.inputNumber.increase"),
        class: x([u(a).e("increase"), u(a).is("disabled", O.value)]),
        onKeydown: g(F, ["enter"])
      }, [
        M(u(j), {
          icon: S.value ? u(de) : u(fe)
        }, null, 8, ["icon"])
      ], 42, Se)), [
        [u(W), F]
      ]) : H("", !0),
      M(u(be), {
        id: e.id,
        ref_key: "input",
        ref: f,
        type: "number",
        step: e.step,
        "model-value": A.value,
        placeholder: e.placeholder,
        readonly: e.readonly,
        disabled: u(b),
        size: u(L),
        max: e.max,
        min: e.min,
        name: e.name,
        label: e.label,
        "validate-event": !1,
        onWheel: n[0] || (n[0] = w(() => {
        }, ["prevent"])),
        onKeydown: [
          g(w(F, ["prevent"]), ["up"]),
          g(w(P, ["prevent"]), ["down"])
        ],
        onBlur: ne,
        onFocus: ee,
        onInput: X,
        onChange: Y
      }, null, 8, ["id", "step", "model-value", "placeholder", "readonly", "disabled", "size", "max", "min", "name", "label", "onKeydown"])
    ], 34));
  }
});
export {
  Re as default
};
