import { CHANGE_EVENT as n, BLUR_EVENT as r, FOCUS_EVENT as u, INPUT_EVENT as a, UPDATE_MODEL_EVENT as i } from "../../../constants/index.js";
import { isNumber as t, isNil as o } from "../../../utils/lodash/index2.js";
const d = {
  /**
   * @description binding value
   */
  modelValue: Number,
  /**
   * @description same as `id` in native input
   */
  id: {
    type: String,
    default: void 0
  },
  /**
   * @description incremental step
   */
  step: {
    type: Number,
    default: 1
  },
  /**
   * @description whether input value can only be multiple of step
   */
  stepStrictly: Boolean,
  /**
   * @description the maximum allowed value
   */
  max: {
    type: Number,
    default: Number.POSITIVE_INFINITY
  },
  /**
   * @description the minimum allowed value
   */
  min: {
    type: Number,
    default: Number.NEGATIVE_INFINITY
  },
  /**
   * @description same as `readonly` in native input
   */
  readonly: Boolean,
  /**
   * @description whether the component is disabled
   */
  disabled: Boolean,
  /**
   * @description size of the component
   */
  size: {
    type: String,
    default: "default"
  },
  /**
   * @description whether to enable the control buttons
   */
  controls: {
    type: Boolean,
    default: !0
  },
  /**
   * @description position of the control buttons
   */
  controlsPosition: {
    type: String,
    default: ""
  },
  /**
   * @description value should be set when input box is cleared
   */
  valueOnClear: {
    type: [String, Number, null],
    default: null
  },
  /**
   * @description same as `name` in native input
   */
  name: String,
  /**
   * @description same as `label` in native input
   */
  label: String,
  /**
   * @description same as `placeholder` in native input
   */
  placeholder: String,
  /**
   * @description precision of input value
   */
  precision: {
    type: Number
  },
  /**
   * @description whether to trigger form validation
   */
  validateEvent: {
    type: Boolean,
    default: !0
  }
}, m = {
  [n]: (e, l) => l !== e,
  [r]: (e) => e instanceof FocusEvent,
  [u]: (e) => e instanceof FocusEvent,
  [a]: (e) => t(e) || o(e),
  [i]: (e) => t(e) || o(e)
};
export {
  m as Emits,
  d as Props
};
