import { UPDATE_MODEL_EVENT as o, INPUT_EVENT as n, CHANGE_EVENT as a, FOCUS_EVENT as i, BLUR_EVENT as l } from "../../../constants/index.js";
import { isString as t } from "../../../utils/lodash/index2.js";
const f = {
  /**
   * @description native input id
   */
  id: {
    type: String,
    default: void 0
  },
  /**
   * @description input box size
   */
  size: {
    type: String,
    default: "default"
  },
  /**
   * @description whether to disable
   */
  disabled: Boolean,
  /**
   * @description binding value
   */
  modelValue: {
    type: [
      String,
      Number,
      Object
    ],
    default: ""
  },
  /**
   * @description type of input
   */
  type: {
    type: String,
    default: "text"
  },
  /**
   * @description control the resizability
   */
  resize: {
    type: String
  },
  /**
   * @description native input autocomplete
   */
  autocomplete: {
    type: String,
    default: "off"
  },
  /**
   * @description format content
   */
  formatter: {
    type: Function
  },
  /**
   * @description parse content
   */
  parser: {
    type: Function
  },
  /**
   * @description placeholder
   */
  placeholder: {
    type: String
  },
  /**
   * @description native input form
   */
  form: {
    type: String
  },
  /**
   * @description native input readonly
   */
  readonly: {
    type: Boolean,
    default: !1
  },
  /**
   * @description native input readonly
   */
  clearable: {
    type: Boolean,
    default: !1
  },
  /**
   * @description toggleable password input
   */
  showPassword: {
    type: Boolean,
    default: !1
  },
  /**
   * @description word count
   */
  showWordLimit: {
    type: Boolean,
    default: !1
  },
  /**
   * @description suffix icon
   */
  suffixIcon: {
    type: Object
  },
  /**
   * @description prefix icon
   */
  prefixIcon: {
    type: Object
  },
  /**
   * @description container role, internal properties provided for use by the picker component
   */
  containerRole: {
    type: String,
    default: void 0
  },
  /**
   * @description native input aria-label
   */
  label: {
    type: String,
    default: void 0
  },
  /**
   * @description input tabindex
   */
  tabindex: {
    type: [String, Number],
    default: 0
  },
  /**
   * @description whether to trigger form validation
   */
  validateEvent: {
    type: Boolean,
    default: !0
  },
  /**
   * @description input or textarea element style
   */
  inputStyle: {
    type: [Object, Array, String],
    default: () => ({})
  },
  /**
   * @description native input autofocus
   */
  autofocus: {
    type: Boolean,
    default: !1
  }
}, p = {
  [o]: (e) => t(e),
  [n]: (e) => t(e),
  [a]: (e) => t(e),
  [i]: (e) => e instanceof FocusEvent,
  [l]: (e) => e instanceof FocusEvent,
  clear: () => !0,
  mouseleave: (e) => e instanceof MouseEvent,
  mouseenter: (e) => e instanceof MouseEvent,
  // NOTE: when autofill by browser, the keydown event is instanceof Event, not KeyboardEvent
  // relative bug report https://github.com/element-plus/element-plus/issues/6665
  keydown: (e) => e instanceof Event,
  compositionstart: (e) => e instanceof CompositionEvent,
  compositionupdate: (e) => e instanceof CompositionEvent,
  compositionend: (e) => e instanceof CompositionEvent
};
export {
  p as Emits,
  f as Props
};
