import type { ExtractPropTypes, PropType } from 'vue';
export declare const Props: {
    /**
     * @description affix element zIndex value
     * */
    readonly zIndex: {
        readonly type: PropType<string | number>;
        readonly default: 100;
    };
    /**
     * @description target container. (CSS selector)
     */
    readonly target: {
        readonly type: StringConstructor;
        readonly default: "";
    };
    /**
     * @description offset distance
     * */
    readonly offset: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
    /**
     * @description position of affix
     * */
    readonly position: {
        readonly type: PropType<"top" | "bottom">;
        readonly default: "top";
    };
};
export declare const Emits: {
    scroll: ({ scrollTop, fixed }: {
        scrollTop: number;
        fixed: boolean;
    }) => boolean;
    change: (fixed: boolean) => boolean;
};
export type AffixEmits = typeof Emits;
export type AffixProps = ExtractPropTypes<typeof Props>;
